unit FractalMainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Fractal1Unit, StdCtrls, Spin, Grids, Fractal2Unit, Fractal3Unit, ComplexUnit,
  ExtCtrls;

type
  TFrmMain = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Frac1: TFractal1;
    SpinDepth: TSpinEdit;
    TabSheet2: TTabSheet;
    Frac2: TFractal2;
    Label2: TLabel;
    EdtStartLeft: TEdit;
    Label3: TLabel;
    EdtStartRight: TEdit;
    Label4: TLabel;
    EdtViewLeft: TEdit;
    Label5: TLabel;
    EdtViewRight: TEdit;
    Label6: TLabel;
    Frac2LbLeft: TLabel;
    Frac2LbRight: TLabel;
    Frac2LbTop: TLabel;
    Frac2LbBottom: TLabel;
    Frac2ButZoomIn: TButton;
    Frac2ButZoomOut: TButton;
    Frac2UpDownVertical: TUpDown;
    UpDownHorizontal: TUpDown;
    ProgFrac2: TProgressBar;
    Frac2ButReset: TButton;
    SpinRadius: TSpinEdit;
    Label1: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    SpinReal: TSpinEdit;
    Label9: TLabel;
    SpinImg: TSpinEdit;
    Label10: TLabel;
    TabSheet3: TTabSheet;
    Frac3: TFractal3;
    ProgFrac3: TProgressBar;
    RadioMode: TRadioGroup;
    Frac3UpDownVertical: TUpDown;
    Frac3UpDownHorizontal: TUpDown;
    Frac3ButZoomIn: TButton;
    Frac3ButZoomOut: TButton;
    Frac3ButReset: TButton;
    Frac3LbLeft: TLabel;
    Frac3LbRight: TLabel;
    Frac3LbBottom: TLabel;
    Frac3LbTop: TLabel;
    Frac3SpinDegree: TSpinEdit;
    Label14: TLabel;
    Frac3SpinIter: TSpinEdit;
    Label15: TLabel;
    procedure SpinDepthChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Frac1InputChange(Sender: TObject);
    procedure Frac2ViewChange(NewRect: TDoubleRect);
    procedure Frac3ViewChange(NewRect: TDoubleRect);
    procedure Frac2Progress(Percent: Double);
    procedure Frac3Progress(Percent: Double);
    procedure Frac2ButZoomInClick(Sender: TObject);
    procedure Frac2ButZoomOutClick(Sender: TObject);
    procedure Frac2UpDownVerticalClick(Sender: TObject; Button: TUDBtnType);
    procedure Frac2UpDownHorizontalClick(Sender: TObject; Button: TUDBtnType);
    procedure Frac2ButResetClick(Sender: TObject);
    procedure SpinRadiusChange(Sender: TObject);
    procedure Frac2SpinChange(Sender: TObject);
    procedure RadioModeClick(Sender: TObject);
    procedure Frac3UpDownVerticalClick(Sender: TObject; Button: TUDBtnType);
    procedure Frac3UpDownHorizontalClick(Sender: TObject;
      Button: TUDBtnType);
    procedure Frac3ButZoomInClick(Sender: TObject);
    procedure Frac3ButZoomOutClick(Sender: TObject);
    procedure Frac3ButResetClick(Sender: TObject);
    procedure Frac3SpinDegreeChange(Sender: TObject);
    procedure Frac3SpinIterChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

procedure TFrmMain.SpinDepthChange(Sender: TObject);
begin
  Frac1.Depth := SpinDepth.Value;
end;


procedure TFrmMain.FormCreate(Sender: TObject);
begin
  Frac1.ShowRangeList;
  Frac2.OnViewChange := Frac2ViewChange;
  Frac2.OnProgress := Frac2Progress;
  Frac2ViewChange(Frac2.View);
  Frac2SpinChange(Self);
  Frac3.OnViewChange := Frac3ViewChange;
  Frac3.OnProgress := Frac3Progress;
  Frac3ViewChange(Frac3.View);
  RadioModeClick(Self);
end;

procedure TFrmMain.Frac1InputChange(Sender: TObject);
var
  R: TRange;
begin
  try
    R.head := StrtoFloat(EdtViewLeft.Text);
    R.tail := StrtoFloat(EdtViewRight.Text);
    Frac1.ViewRange := R;
  except
    on Exception do ;
  end;

  try
    R.head := StrtoFloat(EdtStartLeft.Text);
    R.tail := StrtoFloat(EdtStartRight.Text);
    Frac1.StartRange := R;
  except
    on Exception do ;
  end;
end;

procedure TFrmMain.Frac2ViewChange(NewRect: TDoubleRect);
begin
  Frac2LbLeft.Caption := FloatToStr(NewRect.Left);
  Frac2LbRight.Caption := FloatToStr(NewRect.Right);
  Frac2LbTop.Caption := FloatToStr(NewRect.Top);
  Frac2LbBOttom.Caption := FloatToStr(NewRect.Bottom);
end;

procedure TFrmMain.Frac3ViewChange(NewRect: TDoubleRect);
begin
  Frac3LbLeft.Caption := FloatToStr(NewRect.Left);
  Frac3LbRight.Caption := FloatToStr(NewRect.Right);
  Frac3LbTop.Caption := FloatToStr(NewRect.Top);
  Frac3LbBOttom.Caption := FloatToStr(NewRect.Bottom);
end;

procedure TFrmMain.Frac2Progress(Percent: Double);
begin
  ProgFrac2.Position := Round(Percent * 100);
end;

procedure TFrmMain.Frac3Progress(Percent: Double);
begin
  ProgFrac3.Position := Round(Percent * 100);
end;

procedure TFrmMain.Frac2ButZoomOutClick(Sender: TObject);
var
  NewRect: TDoubleRect;
  HHalf, VHalf: Double;
begin
  NewRect := Frac2.View;
  HHalf := 0.5 * (NewRect.Right - NewRect.Left);
  VHalf := 0.5 * (NewRect.Bottom - NewRect.Top);

  NewRect.Left := NewRect.Left - HHalf;
  NewRect.Right := NewRect.Right + HHalf;
  NewRect.Top := NewRect.Top - VHalf;
  NewRect.Bottom := NewRect.Bottom + VHalf;

  Frac2.View := NewRect;
end;

procedure TFrmMain.Frac2ButZoomInClick(Sender: TObject);
var
  NewRect: TDoubleRect;
  HQuarter, VQuarter: Double;
begin
  NewRect := Frac2.View;
  HQuarter := 0.25 * (NewRect.Right - NewRect.Left);
  VQuarter := 0.25 * (NewRect.Bottom - NewRect.Top);

  NewRect.Left := NewRect.Left + HQuarter;
  NewRect.Right := NewRect.Right - HQuarter;
  NewRect.Top := NewRect.Top + VQuarter;
  NewRect.Bottom := NewRect.Bottom - VQuarter;

  Frac2.View := NewRect;
end;

procedure TFrmMain.Frac2UpDownVerticalClick(Sender: TObject;
  Button: TUDBtnType);
var
  NewRect: TDoubleRect;
  VThird: Double;
begin
  NewRect := Frac2.View;

  VThird := (NewRect.Top - NewRect.Bottom) / 3.0;

  if Button = btNext then //Up
  begin
    NewRect.Top := NewRect.Top + VThird;
    NewRect.Bottom := NewRect.Bottom + VThird;
  end
  else
  begin
    NewRect.Top := NewRect.Top - VThird;
    NewRect.Bottom := NewRect.Bottom - VThird;
  end;

  Frac2.View := NewRect;
end;

procedure TFrmMain.Frac3UpDownVerticalClick(Sender: TObject;
  Button: TUDBtnType);
var
  NewRect: TDoubleRect;
  VThird: Double;
begin
  NewRect := Frac3.View;

  VThird := (NewRect.Top - NewRect.Bottom) / 3.0;

  if Button = btNext then //Up
  begin
    NewRect.Top := NewRect.Top + VThird;
    NewRect.Bottom := NewRect.Bottom + VThird;
  end
  else
  begin
    NewRect.Top := NewRect.Top - VThird;
    NewRect.Bottom := NewRect.Bottom - VThird;
  end;

  Frac3.View := NewRect;
end;

procedure TFrmMain.Frac2UpDownHorizontalClick(Sender: TObject;
  Button: TUDBtnType);
var
  NewRect: TDoubleRect;
  HThird: Double;
begin
  NewRect := Frac2.View;

  HThird := (NewRect.Right - NewRect.Left) / 3.0;

  if Button = btNext then //Right
  begin
    NewRect.Left := NewRect.Left + HThird;
    NewRect.Right := NewRect.Right + HThird;
  end
  else
  begin
    NewRect.Left := NewRect.Left - HThird;
    NewRect.Right := NewRect.Right - HThird;
  end;

  Frac2.View := NewRect;
end;

procedure TFrmMain.Frac2ButResetClick(Sender: TObject);
begin
  Frac2.Reset;
end;

procedure TFrmMain.SpinRadiusChange(Sender: TObject);
begin
  try
    Frac2.Radius := SpinRadius.Value;
  except
    on Exception do ;
  end;
end;

procedure TFrmMain.Frac2SpinChange(Sender: TObject);
var
  NewComplex: TComplex;
begin
  try
    NewComplex.Re := SpinReal.Value / 10;
    NewComplex.Img := SpinImg.Value / 10;
    Frac2.ShiftComplex := NewComplex;
  except
    on Exception do ;
  end;
end;

procedure TFrmMain.RadioModeClick(Sender: TObject);
begin
  if RadioMode.ItemIndex = 1 then
    Frac3.Mode := tf3mRoot
  else
    Frac3.Mode := tf3mSpeed
end;

procedure TFrmMain.Frac3UpDownHorizontalClick(Sender: TObject;
  Button: TUDBtnType);
var
  NewRect: TDoubleRect;
  HThird: Double;
begin
  NewRect := Frac3.View;

  HThird := (NewRect.Right - NewRect.Left) / 3.0;

  if Button = btNext then //Right
  begin
    NewRect.Left := NewRect.Left + HThird;
    NewRect.Right := NewRect.Right + HThird;
  end
  else
  begin
    NewRect.Left := NewRect.Left - HThird;
    NewRect.Right := NewRect.Right - HThird;
  end;

  Frac3.View := NewRect;
end;

procedure TFrmMain.Frac3ButZoomOutClick(Sender: TObject);
var
  NewRect: TDoubleRect;
  HHalf, VHalf: Double;
begin
  NewRect := Frac3.View;
  HHalf := 0.5 * (NewRect.Right - NewRect.Left);
  VHalf := 0.5 * (NewRect.Bottom - NewRect.Top);

  NewRect.Left := NewRect.Left - HHalf;
  NewRect.Right := NewRect.Right + HHalf;
  NewRect.Top := NewRect.Top - VHalf;
  NewRect.Bottom := NewRect.Bottom + VHalf;

  Frac3.View := NewRect;
end;

procedure TFrmMain.Frac3ButZoomInClick(Sender: TObject);
var
  NewRect: TDoubleRect;
  HQuarter, VQuarter: Double;
begin
  NewRect := Frac3.View;
  HQuarter := 0.25 * (NewRect.Right - NewRect.Left);
  VQuarter := 0.25 * (NewRect.Bottom - NewRect.Top);

  NewRect.Left := NewRect.Left + HQuarter;
  NewRect.Right := NewRect.Right - HQuarter;
  NewRect.Top := NewRect.Top + VQuarter;
  NewRect.Bottom := NewRect.Bottom - VQuarter;

  Frac3.View := NewRect;
end;

procedure TFrmMain.Frac3ButResetClick(Sender: TObject);
begin
  Frac3.Reset;
end;

procedure TFrmMain.Frac3SpinDegreeChange(Sender: TObject);
begin
  try
    Frac3.Degree := Frac3SpinDegree.Value;
  except
    on Exception do ;
  end;
end;

procedure TFrmMain.Frac3SpinIterChange(Sender: TObject);
begin
  try
    Frac3.IterTime := Frac3SpinIter.Value;
  except
    on Exception do ;
  end;
end;

end.
